﻿/*----------------------------------------------*/
//  ParaFla Dan★Oniソース 
//  内部処理計算スクリプト
//                ver fd3.4.0 beta  2008/11/08
//                ver fd3.5.0 beta  2009/03/20
//  source by tickle
/*----------------------------------------------*/

/*----- 注意事項 ---------------------------------------------*/
// ・コメント以外の部分で、日本語は使用できません！
// 　(ParaFlaが強制終了するなどの問題が発生します)
// 
//　 何らかの事情で使いたい場合は
//　「最初の初期化」などのところで変数を作ってその変数を使用
//　 Ex.) _root.moji="処理しています";
//
// ・このファイルは色変化のないバージョンです。
// 　使用する場合は「譜面計算」AS のアドレスを「as/arrow_calculate_non.as」にする必要があります。
/*------------------------------------------------------------*/

stop();
//
// ローディング表示部分
var color_moji = "0xcccccc"; //文字色
var cy = Stage.height/2;

createTextField("mes1",1,0,cy-30,Stage.width,30);
fmt1 = new TextFormat("Westminster");
fmt1.size   = 20;
fmt1.color  = color_moji;
fmt1.bold   = false;
fmt1.italic = false;
fmt1.align  = "center";
mes1.setTextFormat(fmt1);

mes1.text="Now Loading...";

mes1.setTextFormat(fmt1);

createTextField("mes2",2,0,cy,Stage.width,30);
fmt2 = new TextFormat("Westminster");
fmt2.size   = 16;
fmt2.color  = color_moji;
fmt2.bold   = false;
fmt2.italic = false;
fmt2.align  = "center";
mes2.setTextFormat(fmt2);
mes2.text   = _root.loading_moji[0];
mes2.setTextFormat(fmt2);

//
// 譜面ファイルの読み込み
function load_tune(){

	// 読み込み完了フラグ → OFF
	var loadOK1     = false;
	_root.loadStart = true;

	//
	// 不要なスプライトのヘッダを格納する配列
	_root.del_spr=[];

	//
	// 変則7keyの矢印設定
	if(_root.keyLabel=="7i"){
		_root.hAr          = _root.hAr7i;
		_root.steprot      = _root.steprot7i;
		_root.frz_list     = _root.frz_list7i;
		_root.del_spr.push("led","rid","fled","frid");	// 左斜め、右斜めは不要
	}else{
		_root.hAr          = _root.hArd;
		_root.steprot      = _root.steprotd;
		_root.frz_list     = _root.frz_listd;
		_root.del_spr.push("gor","iyo");		        // イヨウ、ギコは不要
	}
    //
    // 読み込みする変数の名前（必要な数だけ）
	var arrName =["left","leftdia","down","space","up","rightdia","right","sleft","sdown","sup","sright"];
	var farrName=["frzLeft","frzLdia","frzDown","frzSpace","frzUp","frzRdia","frzRight","sfrzLeft","sfrzDown","sfrzUp","sfrzRight"];

	_root.timeline 	       = new Array();
	_root.ftimeline	       = new Array();

	for(j=0;j<11;j++){
		_root.timeline[j]  = _root[arrName[j]+_root.diffin+"_data"].split(",");
		_root.ftimeline[j] = _root[farrName[j]+_root.diffin+"_data"].split(",");	}
	if(_root.keyLabel==5){
		_root.speed_dac    = _root["speed"+_root.diffin+"_data"].split(",");
	} else {
		_root.speed_dac    = _root["speed"+_root.diffin+"_change"].split(",");
	}
	_root.boost_dac        = _root["boost"+_root.diffin+"_data"].split(",");
	
    if(_root.changeoff=="OFF" || _root.changeoff=="Color"){
        _root.speed_dac    = [];
        _root.boost_dac    = [];
	}
	//
	// 矢印数の算出(オニギリ占有率)
	// 同時に、不要なスプライトのヘッダも調べる
	var allArr=0;	var fallArr=0;
	for(j=0;j<11;j++){
		if(isNaN(parseFloat(_root.timeline[j][0]))){
			_root.del_spr.push(_root.hAr[j]);
		}else{
			allArr +=_root.timeline[j].length;
		}
		if(isNaN(parseFloat(_root.ftimeline[j][0]))){
			_root.del_spr.push("f"+_root.hAr[j]);
		}else{
			fallArr+=_root.ftimeline[j].length/2;	// フリーズは２つで１組
		}
	}
	_root.noFrz =(fallArr==0 ? true : false);

	delete allArr;		delete fallArr;

    //
	// 各オブジェクトが最後に出てくる場所の取得
	var limitm=parseFloat(0);
	for(j=0;j<11;j++){
		if(!isNaN(parseFloat(_root.timeline[j][0]))){
			var idxn   = _root.timeline[j].length-1;
			var limitn = parseFloat(_root.timeline[j][idxn]);
			var chk    = limitn - limitm;
			if(chk > 0){
				limitm = limitn;
			}
		}
		if(!isNaN(parseFloat(_root.ftimeline[j][0]))){
			var idxn   = _root.ftimeline[j].length-1;
			var limitn = parseFloat(_root.ftimeline[j][idxn]);
			var chk    = limitn - limitm;
			if(chk > 0){
				limitm = limitn;
			}
		}
	}

	delete idxm;	delete idxn;
	delete limitn;
	_root.framelimit=limitm+200+_root.correction;

	//
	// 途中再生
    var fade_frame=Math.round(_root.fade_percent/100*_root.framelimit);
	if(_root.startFrame!=0 && _root.startFrame>=fade_frame){
	    _root.frame_num   = _root.startFrame;
	}else{
		_root.frame_num   = fade_frame;
		_root.startFrame  = _root.frame_num;
	}
	//
	// 速度変化・ストップ補正(途中再生の場合はあらかじめ位置調整)
	_root.frame_num = Number(_root.frame_num);
	frame_start=150+_root.frame_num;
	if(_root.frame_num>0){
		if(!isNaN(parseFloat(_root.speed_dac[0]))){
			var sp_start=-1;
			for(j=_root.speed_dac.length-2;j>=0;j-=2){
				if(_root.speed_dac[j]<_root.frame_num){
					sp_start=j;
					break;
				}
			}
			if(sp_start!=-1){
				for(j=0;j<sp_start+1;j++){
					_root.speed_dac.shift();
				}
				_root.speed_dac.unshift(frame_start);
			}
		}
	}

	//
	// 譜面抽出 (座標調整)
	_root.mkArrow  =new Array();
	_root.mkFArrow =new Array();
	_root.frzLength=new Array();
	for(j=0;j<11;j++){
		_root.frzLength[j]=new Array();
	}

	mes2.text=_root.loading_moji[1];
	mes2.setTextFormat(fmt2);

	_root.loadStart=false;
	loadOK1 = true;
	return loadOK1;
}

//
// 速度を配列に変換
function storage_spd(){
	var loadOK15=false;
	_root.loadStart=true;

	spdtmp   =_root.set_spi;
	tmp=0;
	_root.speedTmp=[];

	//
	// 速度を各フレームに格納
	for(f=0;f<=_root.framelimit;f++){
		if(isNaN(parseFloat(_root.speed_dac[tmp]))){
		}else if(f-_root.correction==_root.speed_dac[tmp]){
			spdtmp=Number(_root.speed_dac[tmp+1])*_root.set_spi;
			if(spdtmp>_root.top_spd*2){
				spdtmp=_root.top_spd*2;
			}
			tmp+=2;
		}
		_root.speedTmp[f]=spdtmp;
	}

	if(!isNaN(parseFloat(_root.speed_dac[0])) && _root.speed_dac[0]!=0){
		_root.speed_dac.unshift(0,1);
	}

	mes2.text=_root.loading_moji[2];
	mes2.setTextFormat(fmt2);
	
	_root.loadStart=false;
	loadOK15 = true;
	return loadOK15;
}

//
// Sp.Motion の移動設定
function motion_spd(){
	var loadOK16=false;
	_root.loadStart=true;

    //
    // 最小倍速にあわせてモーション時間を決める
    // (0.25倍速未満の場合はモーション時間が長すぎるため0.25倍速に合わせる)
	_root.mot_array=new Array();
	if(_root.min_multi[_root.dif_shift]<0.25){
		var min_spd   = _root.set_spi*0.25;
	}else{
		var min_spd   = _root.set_spi*_root.min_multi[_root.dif_shift];
	}
	var mot_limit = Math.round(_root.dist_y*3/min_spd)+15;
	var brk_limit =(mot_limit>_root.dist_y/2 ? _root.dist_y/2 : mot_limit);

	for(k=0;k<=mot_limit;k++){
		_root.mot_array[k] = 0;
	}

	if(_root.motion=="OFF"){
	}else if(_root.motion=="Boost"){
        //
        // [ Boost ]
        // ステップゾーンに近づくにつれて加速量が大きくなる
        // (初期倍速に影響、二次関数)
		for(k=16;k<85;k++){
			_root.mot_array[k] = (85-k)*_root.set_spi/50;
		}
	}else if(_root.motion=="Brake"){
        //
        // [ Brake ]
        // 最初は+2、ステップゾーンに近づくにつれて加速量が小さくなる
        // (初期倍速によらず同じ、二次関数)
		for(k=20;k<34;k++){
			_root.mot_array[k] = (k-15)*4/14;
		}
		for(k=34;k<brk_limit;k++){
			_root.mot_array[k] = 4;
		}
	}

	mes2.text=_root.loading_moji[3];
	mes2.setTextFormat(fmt2);
	
	_root.loadStart=false;
	loadOK16 = true;
	return loadOK16;
}

//
// フレームごとの配列に変換
function push_tune(){

	var loadOK2=false;
	_root.loadStart=true;
	
	//
	// フレーム0の矢印が何フレームでステップゾーンに到達するかチェック
	var startY =0;
	var cntlim =(_root.frame_num>0 ? 150+_root.frame_num:0);
	var bstcnt =15;
	while(_root.def_spy-startY>0){
		startY += _root.speedTmp[cntlim];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(_root.speedTmp[cntlim]!=0){
			startY += _root.mot_array[bstcnt];
			bstcnt++;
		}
		cntlim++;
	}

	_root.start_point  = new Array();   // 矢印を出すタイミング
	_root.fstart_point = new Array();   // フリーズアローを出すタイミング
	_root.frzLength	   = new Array();   // フリーズアローのバーの長さ
	_root.initY	       = new Array();   // 矢印の移動距離（端数を含む）
	_root.judgeY	   = new Array();   // 矢印がステップゾーンまでにかかるフレーム数
	_root.bstTime	   = new Array();   // ↑でストップを除いたフレーム数。Sp.Motion用
	del_frz            = new Array();
	del_frz            = [0,0,0,0,0,0,0,0,0,0,0];

	for(j=0;j<11;j++){
        //
        // 矢印をどのタイミングで出すか調べる
	 	if(!isNaN(parseFloat(_root.timeline[j][0]))){
			_root.start_point[j]=new Array();
            //
            // 速度変化が無い場合の対策
			if(!isNaN(parseFloat(_root.speed_dac[0]))){
				var spdn     = _root.speed_dac.length-2;
				var spd_prev = Number(_root.speed_dac[spdn])+_root.correction;
			}else{
				var spd_prev = 0;
			}
			var spd_next     = Infinity;
            
            //
            // 速度変化上の問題から、後ろのデータからチェック
            // 計算し、矢印を出すタイミングを保存
			var lastn = _root.timeline[j].length-1;
			var num   = get_start(j,lastn,_root.timeline[j][lastn],"");

			if(_root.mkArrow[_root.start_point[j][lastn]]==undefined){
				_root.mkArrow[_root.start_point[j][lastn]]=new Array();
			}
			_root.mkArrow[_root.start_point[j][lastn]].push(j);

			for(k=_root.timeline[j].length-2;k>=0;k--){
				//
				// 矢印の出現位置がマイナスになるときは除外
				if(_root.timeline[j][k]-_root.correction<cntlim){
					break;
				//
                // 最初から最後まで同じスピードのときは
                // 計算せず前の矢印データを流用する
				}else if((_root.timeline[j][k]-_root.judgeY[num]>spd_prev) 
					&& (_root.timeline[j][k]< spd_next)){
					var arr_frame = _root.timeline[j][k]-_root.judgeY[num]+_root.correction;
					_root.start_point[j][k] =arr_frame;
					_root.initY[arr_frame]  =_root.initY[num];
					_root.judgeY[arr_frame] =_root.judgeY[num];
					_root.bstTime[arr_frame]=_root.bstTime[num];
				//
				// 合間に速度変化が入るときは別途計算
				}else{
					if(_root.timeline[j][k]<spd_prev){
						spdn    -= 2;
						spd_next = spd_prev;
						spd_prev = Number(_root.speed_dac[spdn])+_root.correction;
					}
					num   = get_start(j,k,_root.timeline[j][k],"");
				}
                //
                // 矢印を出すタイミングを保存
				if(_root.mkArrow[_root.start_point[j][k]]==undefined){
					_root.mkArrow[_root.start_point[j][k]]=new Array();
				}
				_root.mkArrow[_root.start_point[j][k]].push(j);
			}
		}
        
        //
        // フリーズアローをどのタイミングで出すか計算
		if(!isNaN(parseFloat(_root.ftimeline[j][0]))){
			_root.fstart_point[j]=new Array();
			_root.frzLength[j]   =new Array();

            // 速度変化が無い場合の対策
			if(!isNaN(parseFloat(_root.speed_dac[0]))){
				var spdn     = _root.speed_dac.length-2;
				var spd_prev = Number(_root.speed_dac[spdn])+_root.correction;
			}else{
				var spd_prev = 0;
			}
			var spd_next     = Infinity;
            
            //
            // 速度変化上の問題から、後ろのデータからチェック
            // 矢印を出すタイミング、フリーズアローのバーの長さを計算
			var lastn = _root.ftimeline[j].length-2;
			var num   = get_start(j,lastn,_root.ftimeline[j][lastn],"f");
			getfrzlength(j,lastn);

			if(_root.mkFArrow[_root.fstart_point[j][lastn]]==undefined){
				_root.mkFArrow[_root.fstart_point[j][lastn]]=new Array();
			}
			_root.mkFArrow[_root.fstart_point[j][lastn]].push(j);

			for(k=_root.ftimeline[j].length-4;k>=0;k-=2){
				//
				// フリーズアローの出現位置がマイナスになるときは除外
				if(_root.ftimeline[j][k]-_root.correction<cntlim){
					del_frz[j] = k+2;
					break;
                //
                // 最初から最後まで同じスピードのときは
                // 計算せず前のフリーズアローデータを流用する（タイミングのみ）
				}else if((_root.ftimeline[j][k]-_root.judgeY[num]>spd_prev)
					&&(_root.ftimeline[j][k]<spd_next)){
					var arr_frame = _root.ftimeline[j][k]-_root.judgeY[num]+_root.correction;
					_root.fstart_point[j][k]=arr_frame;
					_root.initY[arr_frame]  =_root.initY[num];
					_root.judgeY[arr_frame] =_root.judgeY[num];
					_root.bstTime[arr_frame]=_root.bstTime[num];
				//
				// 合間に速度変化が入るときは別途計算
				}else{
					if(_root.ftimeline[j][k]<spd_prev){
						spdn    -= 2;
						spd_next = spd_prev; 
						spd_prev = Number(_root.speed_dac[spdn])+_root.correction;
					}
					num   = get_start(j,k,_root.ftimeline[j][k],"f");
				}
                //
                // フリーズアローのバーの長さを計算し、
                // フリーズアローの出るタイミングを保存
				getfrzlength(j,k);
				if(_root.mkFArrow[_root.fstart_point[j][k]]==undefined){
					_root.mkFArrow[_root.fstart_point[j][k]]=new Array();
				}
				_root.mkFArrow[_root.fstart_point[j][k]].push(j);
			}
		}
	}
    //
    // 個別加速部分のタイミング調整
	if(!isNaN(parseFloat(_root.boost_dac[0]))){
		del_boost=0;
		for(k=_root.boost_dac.length-2;k>=0;k-=2){
			if(_root.boost_dac[k]<_root.frame_num+5){
				_root.boost_dac[k]=_root.frame_num+5;
				del_boost=k;
				break;
			}else{
				get_bstart(k,_root.boost_dac[k],"boost");
			}
			//
			// スピードの上限設定(個別加速)
			if(_root.boost_dac[k+1]*_root.speedTmp[_root.boost_dac[k]]>_root.top_spd*2){
				if((_root.top_spd*2)/_root.speedTmp[_root.boost_dac[k]]>1){
					_root.boost_dac[k+1]=(_root.top_spd*2)/_root.speedTmp[_root.boost_dac[k]];
				}else{
					_root.boost_dac[k+1]=1;
				}
			}
		}
    }
    
    //
    // 途中変速部分を整理
	_root.arr_spd=[];
	if(_root.frame_num==0){
		_root.arr_spd.push(0);
		_root.arr_spd.push(_root.speedTmp[0]);
	}
	for(s=2;s<_root.speed_dac.length;s+=2){
        var spd_frame=Number(_root.speed_dac[s])+_root.correction;
		_root.arr_spd.push(spd_frame-1);
		_root.arr_spd.push(_root.speedTmp[spd_frame]);
	}

	delete _root.speedTmp;
	delete spd_prev;	delete spd_next;
	delete spdn;		delete num;
	
	mes2.text=_root.loading_moji[4];
	mes2.setTextFormat(fmt2);

	_root.loadStart=false;
	loadOK2 = true;
	return loadOK2;
}

//
// 規定距離に達するまでのフレーム数取得
function get_start(j,k,num,header){
	var startY =0;
	var cnt    =0;
	var bstcnt =15;
	num -= -_root.correction;

	while(_root.def_spy-startY>0){
		startY += _root.speedTmp[num];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(_root.speedTmp[num]!=0){
			startY += _root.mot_array[bstcnt];
			bstcnt++;
		}
		num--;
		cnt++;
	}
	_root[header+"start_point"][j][k]=num;
	_root.initY[num]  =startY;		// 矢印の移動距離（端数を含む）
	_root.judgeY[num] =cnt;			// 矢印がステップゾーンまでにかかるフレーム数
	_root.bstTime[num]=bstcnt;		// ↑でストップを除いたフレーム数。Sp.Motion用

	return num;
}

//
// 逆算してどのタイミングで個別加速・色変化するかを計算
function get_bstart(k,num,d_type){
	var startY =0;
	var cnt    =0;
	var bstcnt =15;
	num -= -_root.correction;

	while(_root.def_spy-startY>0){
		startY += _root.speedTmp[num];
		//
		// Sp.Motionによる追加スピード（ストップを除く）
		if(_root.speedTmp[num]!=0){
			startY += _root.mot_array[bstcnt];
			bstcnt++;
		}
		num--;
		cnt++;
	}
	_root[d_type+"_dac"][k] =num;
    
    return cnt;
}

//
// フリーズアローの押しっぱなし部分の長さを取得
function getfrzlength(j,k){
	var lgth=0;
	var st=Number(_root.ftimeline[j][k])+_root.correction;
	var en=Number(_root.ftimeline[j][k+1])+_root.correction;
	for(fz=st;fz<en;fz++){
		lgth += _root.speedTmp[fz];
	}
	_root.frzLength[j][k]=lgth;
}

//
// 不要な変数を削除 (読み込み変数 及び 一時変数)
// 同時に、前もって初期化できる部分は初期化しておく
function del_temporary(){

	var loadOK3=false;
	_root.loadStart=true;
	//
	// 指定フレーム以外の速度変化・ストップを削除
	for(k=0;k<del_boost;k++){
		_root.boost_dac.shift();
	}

	for(j=0;j<11;j++){
		for(k=0;k<del_frz[j];k++){
			_root.frzLength[j].shift();
		}
		delete _root[arrName[j]+"_data"];
		delete _root[farrName[j]+"_data"];
	}
	delete _root.speed_data;
	delete _root.speed_change;
	delete _root.boost_data;
	for(k=2;k<=_root.difficulty;k++){
		for(j=0;j<11;j++){
			delete _root[arrName[j]+k+"_data"];
			delete _root[farrName[j]+k+"_data"];
		}
		delete _root["speed"+k+"_data"];
		delete _root["speed"+k+"_change"];
		delete _root["boost"+k+"_data"];
	}
	delete _root.timeline;
	delete _root.ftimeline;
	delete _root.start_point;
	delete _root.fstart_point;
	delete _root.speed_dac;

	delete _root.keyLine;
	delete _root.ctrlLe;	delete _root.ctrlLed;	delete _root.ctrlDo;
	delete _root.ctrlOni;	delete _root.ctrlUp;	delete _root.ctrlRid;	delete _root.ctrlRi;
	delete _root.scr;	delete _root.pscr;	
	delete _root.msg;	delete _root.option;	delete _root.resmes;

	mes1.text="Complete!";
	mes1.setTextFormat(fmt1);
	
	//
	// 生成する矢印番号の初期化
	for(j=0;j<11;j++){
		_root[_root.hAr[j]+"s"]    =0;
		_root["f"+_root.hAr[j]+"s"]=0;
	}

	// 読み込み完了フラグ → ON
	loadOK3 =true;
	return loadOK3;
}